"""
// © University of Southampton IT Innovation Centre, 2018
//
// Copyright in this software belongs to University of Southampton
// IT Innovation Centre of Gamma House, Enterprise Road,
// Chilworth Science Park, Southampton, SO16 7NS, UK.
//
// This software may not be used, sold, licensed, transferred, copied
// or reproduced in whole or in part in any manner or form or in or
// on any media by any person other than in accordance with the terms
// of the Licence Agreement supplied with the software, or otherwise
// without the prior written consent of the copyright owners.
//
// This software is distributed WITHOUT ANY WARRANTY, without even the
// implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE, except where stated in the Licence Agreement supplied with
// the software.
//
//      Created By :            Nikolay Stanchev
//      Created Date :          15-05-2018
//      Created for Project :   FLAME
"""

from pyramid.config import Configurator
from pyramid.settings import asbool
from clmcservice.views import AggregatorConfig


def main(global_config, **settings):
    """ This function returns a Pyramid WSGI application."""

    # a conversion is necessary so that the configuration value of the aggregator is stored as bool and not as string
    aggregator_running = asbool(settings.get('aggregator_running', 'false'))
    settings['aggregator_running'] = aggregator_running

    config = Configurator(settings=settings)

    config.add_route('aggregator', '/aggregator')
    config.add_view(AggregatorConfig, attr='get', request_method='GET')
    config.add_view(AggregatorConfig, attr='post', request_method='POST')

    config.scan()
    return config.make_wsgi_app()
